/*
 * CandelLightEffect.c
 *
 * Created: 20.11.2016 15:59:56
 *  Author: Thomas
 */ 


#include <avr/io.h>
#include <stdlib.h>
#include "../main.h"
#include "CandelLightEffect.h"

extern uint8_t HSV_H_Value;
extern uint8_t HSV_S_Value;
extern uint8_t HSV_V_Value;


void CandelLightEffectInit()
{
	for (uint8_t i = 0; i < LEDCount; i++)
	{
		LEDStripe[i].HSV.H = HSV_H_Value;
		LEDStripe[i].HSV.S = HSV_S_Value;
		LEDStripe[i].HSV.V = 0;
		
		LEDStripe[i].HSV.V = 32;
		LEDStripe[i].FlickerDelay = RAND_FLICKER_DELAY();
		LEDStripe[i].MicroFlickerDelay = RAND_MICRO_FLICKER();
	}
}




void CandelLightEffect()
{
	for (uint8_t i = 0; i < LEDCount; i++)
	{
		LEDStripe[i].HSV.H = HSV_H_Value;
	
		
		if (!(--LEDStripe[i].MicroFlickerDelay))
		{
			LEDStripe[i].MicroFlickerDelay = RAND_MICRO_FLICKER();
			//LEDStripe[i].HSV.V ^= 0x08;
		}
		
		if (LEDStripe[i].FlickerDelay)
		{
			if (--LEDStripe[i].FlickerDelay)
			{
				continue;;
			}

			LEDStripe[i].HSV.V = RAND_FLICKER_V_VALUE();
			LEDStripe[i].FlickerDuration = RAND_FLICKER_DURATION();
			LEDStripe[i].FlickerOffSpeed = RAND_FLICKER_OFF_SPEED();

			continue;
		}


		if (LEDStripe[i].FlickerDuration)
		{
			LEDStripe[i].FlickerDuration--;
			continue;
		}

		
		if ((LEDStripe[i].HSV.V + LEDStripe[i].FlickerOffSpeed) >= 127)
		{
			LEDStripe[i].HSV.V = 127;
			
			LEDStripe[i].FlickerDelay = RAND_FLICKER_DELAY();
		}
		else
		{
			LEDStripe[i].HSV.V += LEDStripe[i].FlickerOffSpeed;
		}
	}
	
}

	
