/*
 * CandelLightEffect.c
 *
 * Created: 20.11.2016 15:59:56
 *  Author: Thomas
 */ 

#include <avr/io.h>
#include <stdlib.h>
#include "../BasicTypes.h"

#include "CandelLightEffect.h"
#include "../main.h"


CandelLightEffect_T CandelLightEffectStripe[LED_COUNT];

extern uint8_t HMI_AdjustmentHSV_H;
extern uint8_t HMI_AdjustmentHSV_S;


void CandelLightEffectInit(void)
{
	for (uint8_t i = 0; i < LED_COUNT; i++)
	{
		CandelLightEffectStripe[i].HSV.V = MAX_BRIGHTNESS;
		CandelLightEffectStripe[i].FlickerDelay = RAND_FLICKER_DELAY();
		CandelLightEffectStripe[i].MicroFlickerDelay = RAND_MICRO_FLICKER_DELAY();
		CandelLightEffectStripe[i].StateMachine = FlickerDelay;
	}
}


void CandelLightEffect(uint8_t colorShift)
{
	uint8_t tmpHSV_H = HMI_AdjustmentHSV_H + colorShift;

	int16_t tmpLEDiHSV_V;
	
	for (uint8_t i = 0; i < LED_COUNT; i++)
	{
		CandelLightEffectStripe[i].HSV.H = tmpHSV_H;
		CandelLightEffectStripe[i].HSV.S = HMI_AdjustmentHSV_S;
		
		tmpLEDiHSV_V = (int16_t)CandelLightEffectStripe[i].HSV.V;
		
		switch (CandelLightEffectStripe[i].StateMachine)
		{
			case FlickerDelay:
			{
				if (!(--CandelLightEffectStripe[i].FlickerDelay))
				{
					CandelLightEffectStripe[i].StateMachine = FlickerDown;
				}
				else if (!(--CandelLightEffectStripe[i].MicroFlickerDelay))
				{
					CandelLightEffectStripe[i].StateMachine = MicroFlickerDown;
				}
			}
			break;


			case FlickerDown:
			{
				tmpLEDiHSV_V -= 8;
				
				if (tmpLEDiHSV_V <= FLICKER_BRIGHTNESS)
				{
					tmpLEDiHSV_V = FLICKER_BRIGHTNESS;
					CandelLightEffectStripe[i].StateMachine = FlickerUp;
				}
			}
			break;


			case FlickerUp:
			{
				tmpLEDiHSV_V += 2;
				
				if (tmpLEDiHSV_V >= MAX_BRIGHTNESS)
				{
					tmpLEDiHSV_V = MAX_BRIGHTNESS;
					CandelLightEffectStripe[i].FlickerDelay = RAND_FLICKER_DELAY();
					CandelLightEffectStripe[i].StateMachine = FlickerDelay;
				}
			}
			break;


			case MicroFlickerDown:
			{
				tmpLEDiHSV_V -= 4;
				
				if (tmpLEDiHSV_V <= MICRO_FLICKER_BRIGHTNESS)
	 			{
					tmpLEDiHSV_V = MICRO_FLICKER_BRIGHTNESS;
					CandelLightEffectStripe[i].StateMachine = MicroFlickerUp;
				}
			}
			break;


			case MicroFlickerUp:
			{
				tmpLEDiHSV_V += 2;

				if (tmpLEDiHSV_V >= MAX_BRIGHTNESS)
				{
					tmpLEDiHSV_V = MAX_BRIGHTNESS;
					CandelLightEffectStripe[i].MicroFlickerDelay = RAND_MICRO_FLICKER_DELAY();
					CandelLightEffectStripe[i].StateMachine = FlickerDelay;
				}
			}
			break;
		} // switch
	
		CandelLightEffectStripe[i].HSV.V = (uint8_t)tmpLEDiHSV_V;
	} // for
}

	
