/*
 * CandelLightEffect.h
 *
 * Created: 20.11.2016 16:00:08
 *  Author: Thomas
 */ 


#ifndef CANDELLIGHTEFFECT_H_
#define CANDELLIGHTEFFECT_H_


#include <avr/io.h>

#include "../main.h"
#include "../HSV2RGB/HSV2RGB.h"



#define MAX_BRIGHTNESS 255
#define FLICKER_BRIGHTNESS 96
#define MICRO_FLICKER_BRIGHTNESS 200

#define RAND_FLICKER_DELAY() ((uint16_t)(((uint32_t)rand() * (1000-100)) >> 16) + 100)		// 1-10 Seconds (10ms Base)
#define RAND_MICRO_FLICKER_DELAY() ((uint16_t)(((uint32_t)rand() * (200-100)) >> 16) + 100)	// 1-2 Seconds (10ms Base)


typedef enum tagCandelLightStateMachine {
	FlickerDelay,
	FlickerDown,
	FlickerUp,
	MicroFlickerDown,
	MicroFlickerUp,
} CandelLightStateMachine_T, *pCandelLightStateMachine_T;


typedef struct tagCandelLightEffect {
	HSV_T HSV;
	uint16_t FlickerDelay;
	uint16_t MicroFlickerDelay;
    CandelLightStateMachine_T StateMachine;
} CandelLightEffect_T, *pCandelLightEffect_T;


void CandelLightEffectInit(void);
void CandelLightEffect(uint8_t colorShift);


#endif /* CANDELLIGHTEFFECT_H_ */