/*
 * RainbowEffect.c
 *
 * Created: 12.12.2016 19:25:37
 *  Author: Thomas
 */ 

#include <avr/io.h>
#include <avr/pgmspace.h>
#include "../BasicTypes.h"

#include "RainbowEffect.h"
#include "../main.h"


RainbowEffect_T RainbowEffectStripe[LED_COUNT];

extern uint8_t HMI_AdjustmentHSV_H;
extern uint8_t HMI_AdjustmentHSV_S;


static uint8_t EffectV;


void RainbowEffectInit()
{
	for (uint8_t i = 0; i < LED_COUNT; i++)
	{
		RainbowEffectStripe[i].HSV.V = 255;
	}
}


void RainbowEffect()
{
	static uint8_t SlowDown;
	
	if (!(SlowDown ^= 0xff))
	{
		return;
	}
	
	uint8_t tmpHSV_S = HMI_AdjustmentHSV_S;
	
	for (uint8_t i = 0; i < LED_COUNT; i++)
	{
		RainbowEffectStripe[i].HSV.S = tmpHSV_S;
	}
	
	EffectV += 1;

	for (uint8_t i = 0; i < HALF_LED_COUNT; i++)
	{
		uint8_t tmpEffectV = EffectV+(i*10);
		
		RainbowEffectStripe[i].HSV.H = tmpEffectV;
		RainbowEffectStripe[(LED_COUNT-1)-i].HSV.H = tmpEffectV;
	}
}
