/*
 * SnowEffect.c
 *
 * Created: 12.12.2016 19:25:37
 *  Author: Thomas
 */ 

#include <avr/io.h>
#include <stdlib.h>
#include "../BasicTypes.h"

#include "SnowEffect.h"
#include "../main.h"


SnowEffect_T SnowEffectStripe[LED_COUNT];

extern uint8_t HMI_AdjustmentHSV_H;
extern uint8_t HMI_AdjustmentHSV_S;


void SnowEffectInit(void)
{
	for (uint8_t i = 0; i < LED_COUNT; i++)
	{
		SnowEffectStripe[i].HSV.V = 255;
	}
}


void SnowEffect(uint8_t colorShift)
{
	static uint8_t SlowDownCounter;
	static uint16_t SnowFlakeDelayCounter;
	static uint16_t SnowShowerDelayCounter;
	static uint8_t SnowShowerIsActiv;
	
	
	if (!SnowShowerDelayCounter)
	{
		SnowShowerDelayCounter = RAND_SNOW_SHOWER_DELAY();
		SnowShowerIsActiv ^= 0xff;
	}
	SnowShowerDelayCounter--;
	

	if (++SlowDownCounter >= 25)
	{
		SlowDownCounter = 0;
			
		for (uint8_t i = 0; i < HALF_LED_COUNT-1; i++)
		{
			SnowEffectStripe[i] = SnowEffectStripe[i+1];
		}
			
		for (uint8_t i = LED_COUNT-1; i > HALF_LED_COUNT; i--)
		{
			SnowEffectStripe[i] = SnowEffectStripe[i-1];
		}
	
		if (SnowShowerIsActiv)
		{
			if (!SnowFlakeDelayCounter)
			{
				SnowFlakeDelayCounter = RAND_SNOW_FLAKE_DELAY();

				SnowEffectStripe[HALF_LED_COUNT-1].IsSnowFlake = TRUE;
				SnowEffectStripe[HALF_LED_COUNT-1].FlickerDelay = 0;
			}
			else
			{
				SnowEffectStripe[HALF_LED_COUNT-1].IsSnowFlake = FALSE;
			}
		}
	}
		
	if (SnowFlakeDelayCounter)
	{
		SnowFlakeDelayCounter--;
	}
	
	
	uint8_t tmpHSV_H = HMI_AdjustmentHSV_H + colorShift;
	
	for (uint8_t i = 0; i < HALF_LED_COUNT; i++)
	{
		SnowEffectStripe[i].HSV.H = tmpHSV_H;
		
		if (!SnowEffectStripe[i].IsSnowFlake)
		{
			SnowEffectStripe[i].HSV.S = HMI_AdjustmentHSV_S;
			continue;			
		}

		if (!SnowEffectStripe[i].FlickerDelay)
		{
			SnowEffectStripe[i].FlickerDelay = RAND_SNOW_FLICKER_DELAY();
			
			if (SnowEffectStripe[i].HSV.S)
			{
				SnowEffectStripe[i].HSV.S = 0;
			}
			else
			{
				SnowEffectStripe[i].HSV.S = HMI_AdjustmentHSV_S;
			}			
		}
		else
		{
			SnowEffectStripe[i].FlickerDelay--;
		}
	}

	for (uint8_t i = 0; i < HALF_LED_COUNT; i++)
	{
		SnowEffectStripe[(LED_COUNT-1)-i].HSV = SnowEffectStripe[i].HSV;
	}
		
}

