/*
 * Time.c
 *
 * Created: 16.11.2016 19:15:01
 *  Author: Thomas
 */ 

#include <avr/io.h>
#include "../BasicTypes.h"

#include "TimerClock.h"


uint8_t ClockPulse10ms;
uint8_t ClockPulse100ms;
uint8_t ClockPulse1s;


void TimerClockInit(void)
{
	#define TIMER1MS (F_CPU / 8 / 100)

	TCCR1B |= (2 << CS10);	// DIV 8
}


void TimerClock(void)
{
	static uint16_t TimerPeriodCompare;
	static uint8_t CounterClockPulse10ms;
	static uint8_t CounterClockPulse100ms;
	
	ClockPulse10ms = FALSE;
	ClockPulse100ms = FALSE;
	ClockPulse1s = FALSE;
	
	if ((TCNT1 - TimerPeriodCompare) >= TIMER1MS)
	{
		TimerPeriodCompare += TIMER1MS;
	
		ClockPulse10ms = TRUE;
		
		if(++CounterClockPulse10ms >= 10)
		{
			CounterClockPulse10ms = 0;
			ClockPulse100ms = TRUE;
			
			if(++CounterClockPulse100ms >= 10)
			{
				CounterClockPulse100ms = 0;
				ClockPulse1s = TRUE;
			}
		}
	}
}
